#include <sdsl/int_vector.hpp>
#include <sdsl/rank_support_v.hpp>
#include <sdsl/suffixarrays.hpp>
#include <sdsl/testutils.hpp>
#include <iostream>

using namespace sdsl;
using namespace std;

typedef bit_vector::size_type size_type;

void seqential_access(const bit_vector &b){
	size_type x=0;
	for(size_type i=0,y=231; i<b.size(); ++i){
		y%=b.size();
		x += b[y];
		y=y+1;
	}
	cout << x << endl;
}

void ram_access(const bit_vector &b){
	size_type x=0;
	for(size_type i=0,y=231; i<b.size(); ++i){
		y%=b.size();
		x += b[y];
		y=(y*y-1);
	}
	cout << x << endl;
}

size_type backward_search_pattern(csa_wt<> &csa, char *pattern, size_type len){
	size_type lb=0, rb=csa.size(); // left bound inclusive, right bound exclusive
	for(size_type i=len; i>0; --i){// for each character in the pattern
		size_type c = pattern[i-1];
		if(c==0)
			return 0;
		size_type cc = csa.char2comp[c];
		size_type c_begin = csa.C[cc]; // interval begin of character c (inclusive)
		size_type c_end = csa.C[cc+1]; // interval end of character c (exclusive)
		if(c_begin==c_end)
			return 0;
		size_type occs_before_lb = csa.rank_bwt(lb, c);
		size_type occs_before_rb = csa.rank_bwt(rb, c);
		lb = c_begin + occs_before_lb;
		rb = c_begin + occs_before_rb;
	}
	return rb-lb;
}

int main(){
/*	
	bit_vector b(10000000);
	for(size_type i=0,x=243; i<b.size(); ++i){
		x = (x*x-1)%1000000009;
		b[i] = x & (size_type)1;
	}
	seqential_access(b);
	ram_access(b);
*/
	char *c=NULL;
	size_type n=0;
	if( (n=file::readText("test_cases/small/dna.1MB", c)) > 0 ){
/*		size_type cnt[256]; for(int i=0; i<256; ++i) cnt[i] = 0;
		bit_vector bv[256];
		size_type sigma = 0;
		for(size_type i=0; i<n; ++i){
			if( cnt[c[i]]++ == 0 ){
				++sigma;
				bv[c[i]] = bit_vector(n);
				bv[c[i]][i] = 1;	
			}else{
				bv[c[i]][i] = 1;
			}
		}	
		cout << "sigma=" << sigma << endl;
		rank_support_v<> rbv[256];
		for(int i=0; i<256; ++i)
			if(bv[i].size()>0)
				rbv = rank_support_v<>(&bv[i]);
*/
		csa_wt<> csa_dna;
		ifstream in("/tmp/csa_wt.data");
		if( !in  ){
			csa_dna = csa_wt<>((const unsigned char*)c);
			util::store_to_file(csa_dna, "/tmp/csa_wt.data");
		}
		else{
			util::load_from_file(csa_dna, "/tmp/csa_wt.data");
		}
		char * pattern = new char[21];
		size_type pos=1234, len=20;
//		for(size_type i=pos; i<pos+len; ++i)
//			pattern[i-pos] = c[i];
//		pattern[len]=0;
		for(size_type i=0; i<100000;++i){
//			cout << backward_search_pattern(csa_dna, pattern, len) << endl;
			cout << backward_search_pattern(csa_dna, c+i, len) << endl;
		}
		delete [] c;
		delete pattern;
/*		cout << "sigma = " << (int)csa_dna.sigma << endl;
		size_type res=0;
		for(size_type i=0; i<csa_dna.size();++i){
			res += csa_dna[i];
		}
		cout << res << endl;
*/		
	}	
}
