#include "int_vector.hpp"
#include "wavelet_tree.hpp"


namespace sdsl{

namespace algorithm{	
	// Transform the suffix array to the lcp array of the given suffix array and the text.
	/*!
	 * \param sa 	The suffix array of the text.
	 * \param text  The text of length sa.size().
	 */	
	template<class WaveletTree, class RandomAccessContainer>	
	void sa2lcp(RandomAccessContainer &sa, unsigned char *text){
		typedef RandomAccessContainer::size_type size_type;
		unsigned char * bwt = new unsigned char[sa.size()+1];
		size_type sa_1 = 0;
		// calculate bwt
		for(size_type i=0; i<sa.size(); ++i){
			if( sa[i] ){
				bwt[i] = text[sa[i]-1];
			}else{
				bwt[i] = 0;
				sa_1 = i;
			}
		}
		// build the wavelet tree of the bwt
		WaveletTree wt(bwt, sa.size());
		delete [] bwt;

		lcp[0] = 0;
		size_type i=0,j,k,l=0;
		for(i=0; i<sa.size(); ++i){
			if( sa_1 ){
				k = sa[j-1];
				while( text[k+l]==text[i+l] )
					++l;
				lcp[j] = l;
				l = (l==0)?0:l-1;
			}
			sa_1 = psi(sa_1);
		}		
		
	}	

}// end namespace algorithm
}// end namespace sdsl
