/* sdsl - succinct data structures library
    Copyright (C) 2008 Simon Gog 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see http://www.gnu.org/licenses/ .
*/
/*! \file suffixarrays.hpp
    \brief suffixarrays.hpp contains generic classes for different suffix array classes.
	\author Simon Gog
*/
#ifndef INCLUDED_SDSL_SUFFIXARRAYS
#define INCLUDED_SDSL_SUFFIXARRAYS

/** \defgroup csa Compressed Suffix Arrays (CSA) */

#include "csa_uncompressed.hpp"
#include "csa_wt.hpp"
#include "csa_sada_theo.hpp"
#include "csa_sada_prac.hpp"

#endif
