/* sdsl - succinct data structures library
    Copyright (C) 2009 Simon Gog 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see http://www.gnu.org/licenses/ .
*/

#include "sdsl/util.hpp"
#include "cxxabi.h"
namespace sdsl{
namespace util{


uint64_t get_pid(){
	return getpid();
} 

std::string demangle(const char* name){
#ifndef HAVE_CXA_DEMANGLE
	char buf[4096];
	size_t size = 4096;
	int status = 0;
	abi::__cxa_demangle(name, buf, &size, &status);
	if(status==0)
		return std::string(buf);
	return std::string(name);
#else
	return std::string(name);
#endif	
}

}// end namespace util
}// end namespace sdsl

