#define BOOST_TEST_DYN_LINK
#define BOOST_TEST_MAIN 
#include <boost/test/unit_test.hpp>
#include <boost/filesystem.hpp>
#include <sdsl/testutils.hpp>
#include <sdsl/algorithms.hpp>
#include <sdsl/cst_sct.hpp>
#include <sdsl/cst_sada.hpp>
#include <vector>
#include <string>
#include <iomanip>
#include <set>
//#include <algorithm> // for stl conform test 
//#include <fstream>
#if BOOST_WORKAROUND( __GNUC__, < 3 )
typedef boost::test_tools::output_test_stream onullstream_type;
#else
#include <boost/test/utils/nullstream.hpp>
typedef boost::onullstream onullstream_type;
#endif

using namespace boost::unit_test;
using namespace boost::filesystem;
using namespace sdsl;
using std::string;

//const uint32_t sample_psi = 256;
//const uint16_t sample_sa = 16;
//typedef csa_sada_prac<enc_vector_prac<coder::fibonacci,sample_psi>, sample_sa> tCSAFib;
typedef cst_sct<cst_sct<>::csa_type, cst_sct<>::lcp_type, balanced_parentheses_support_g<> > cst_type;
typedef cst_type::size_type size_type;
typedef cst_type::node_type node_type;
typedef cst_type::size_type size_type;

size_type dfs(const cst_type& cst,node_type v){
//	if(!cst.is_leaf(v)){
//		for(size_type i=0;i<v.l;++i)std::cerr<<" ";
//		std::cerr<<v.l<<"-["<<v.left<<","<<v.right<<"]"<<std::endl;
//	}
	size_type result = 1;
	node_type temp = cst.root();
	size_type i=1;
	while( (temp=cst.ith_child(v,i)) != cst.root() ){ 
		++i;
		result += dfs(cst, temp);
	}
	return result;
}

BOOST_AUTO_TEST_SUITE( cst_sct_test_suite )

BOOST_AUTO_TEST_CASE( constructor_test ){
	unit_test_log.set_threshold_level( log_messages );
//	BOOST_TEST_MESSAGE("argc = "<<boost::unit_test::framework::master_test_suite().argc);
//	BOOST_TEST_MESSAGE("argv[0] = "<<boost::unit_test::framework::master_test_suite().argv[0]);
	BOOST_TEST_MESSAGE( "Running tests for the construction of cst_sct ..." );

/*	
	cst_sada<> cst_s((const unsigned char*)"ctaataatg");
	cst_sct<>  cst_c((const unsigned char*)"ctaataatg");
	BOOST_MESSAGE( "leaves in the subtree = " <<  cst_s.leaves_in_the_subtree(cst_s.root()) );
	BOOST_MESSAGE( "leaves in the subtree = " <<  cst_c.leaves_in_the_subtree(cst_c.root()) );
	typedef cst_sada<>::node_type cst_sada_node_type;
	cst_sada_node_type child_s = cst_s.ith_child( cst_s.root(), 1 );
	node_type child_c 		   = cst_c.ith_child( cst_c.root(), 1 );	
	BOOST_MESSAGE( "leaves in the subtree = " <<  cst_s.leaves_in_the_subtree(child_s) );
	BOOST_MESSAGE( "leaves in the subtree = " <<  cst_c.leaves_in_the_subtree(child_c) );
	child_s = cst_s.sibling( child_s );
	child_c = cst_c.sibling( child_c );
	BOOST_MESSAGE( "leaves in the subtree = " <<  cst_s.leaves_in_the_subtree(child_s) );
	BOOST_MESSAGE( "leaves in the subtree = " <<  cst_c.leaves_in_the_subtree(child_c) );
	return;
*/


	onullstream_type dev_null;
	path test_file_dir("./test_cases_small/");
	for(directory_iterator dir_it(test_file_dir), end; dir_it != end; ++dir_it){
		if( is_regular( dir_it->status() ) ){
			if(file_size( *dir_it ) > 100 ){
//				continue;
			}
			string test_case = dir_it->path().leaf();	
			BOOST_MESSAGE("test case: "<<test_case);
			char *text = NULL;
			size_type size = 0;
			if( (size = file::readText( dir_it->path().file_string().c_str(), text )) > 0 ){
				BOOST_MESSAGE("create cst");
				cst_type cst((const unsigned char*)text);
				BOOST_MESSAGE("cst was created");
				BOOST_MESSAGE("alphabet size = "<<(int)cst.csa.sigma);
				std::string alphabet = "";
				for(size_type i=0; i<cst.csa.sigma; ++i){
					alphabet += cst.csa.comp2char[i];	
				}
				BOOST_MESSAGE("\""+alphabet+"\"");

				bool tested_serialize_and_load = false;
test_methods:

				for(size_type i=0; i<cst.csa.size() and !tested_serialize_and_load and cst.csa.size() < 100; ++i){
					BOOST_MESSAGE(" "<<std::setw(3)<<i<<std::setw(3)<<cst.csa[i]<<" "<<std::setw(3)<<cst.csa(i)<<" "<<std::setw(3)<<cst.lcp[i]);
				}
				for(size_type i=0; i<cst.csa.sigma; ++i){
					node_type node = cst.ith_child(cst.root(), i+1);
					BOOST_MESSAGE(node.l<<"-["<<node.left<<","<<node.right<<"] "<<node.right-node.left<<" "<<cst.edge(node, 1));
				}
//				continue;
				std::set<node_type> nodes;
				node_type root = cst.root();
				nodes.insert(root);
				BOOST_MESSAGE("Test parent(v).");
				for(size_type i=0; i<cst.csa.size(); ++i){
					node_type node = cst.ith_leaf(i+1);	
					while( nodes.find(node) == nodes.end()  ){
						nodes.insert(node);
						BOOST_REQUIRE( nodes.size() < 2*cst.csa.size() );
						node_type oldnode = node;
						node = cst.parent(node);

						if(node.l == 1/* == node_type(1,2937,2937)*/ ){
						//	std::cerr<<"child of 1-[2937,2937]: "<<oldnode.l<<"-["<<oldnode.left<<","<<oldnode.right<<"]"<<std::endl;
							std::cerr<<"child of 1-[*,*]: "<<oldnode.l<<"-["<<oldnode.left<<","<<oldnode.right<<"]"<<std::endl;
						}
					}
				}
				BOOST_MESSAGE("Cst consists of "<<nodes.size()<<" nodes.");
				std::vector<node_type> nodesvec(nodes.begin(), nodes.end());	

				BOOST_MESSAGE("Test sibling(v).");
				for(size_type i=0; i<nodesvec.size(); ++i){
					node_type v = nodesvec[i];
					node_type s1 = cst.sibling(v), s2 = cst.sibling_naive(v);
					if( s1 != s2 ){
						BOOST_MESSAGE(" v = "<<v<<" parent = "<< cst.parent(v) );
						BOOST_MESSAGE(" sibling = "<< s1 <<" sibling_naive = "<< s2 );
					}
					BOOST_REQUIRE( s1 == s2 );
				}

/*				
				BOOST_MESSAGE("Test lca(v,w).");
				for(size_type i=0; i<10*nodes.size(); ++i){
					size_type nr1 = rand()%nodes.size(), nr2 = rand()%nodes.size();
					node_type v = nodesvec[nr1], w = nodesvec[nr2];
					node_type lca = cst.lca(v,w);
					node_type vv = v, ww = w;
					while( vv != ww ){
						if( vv.l > ww.l ){
							vv = cst.parent(vv);
						}else{
							ww = cst.parent(ww);
						}
					}
					if(lca!=vv){
						std::cerr<<"v = "<<v.l<<"-["<<v.left<<","<<v.right<<"]"<<std::endl;
						if(v.l and v.left and v.right<cst.csa.size()-1){
							std::cerr<<cst.lcp[v.left]<<","<<cst.lcp[v.right+1]<<std::endl;
							for(size_type i=1; i <= v.l and i < 30; ++i)
								std::cerr<<cst.edge(v, i);
						}
						std::cerr<<std::endl;
						std::cerr<<"w = "<<w.l<<"-["<<w.left<<","<<w.right<<"]"<<std::endl;
						if(w.l and w.left and w.right<cst.csa.size()-1){
							std::cerr<<cst.lcp[w.left]<<","<<cst.lcp[w.right+1]<<std::endl;
							for(size_type i=1; i <= w.l and i < 30; ++i)
								std::cerr<<cst.edge(w, i);
						}
						std::cerr<<std::endl;
						ww = w;
						while(ww!=vv){
							ww = cst.parent(ww);
							std::cerr<<ww.l<<"-["<<ww.left<<","<<ww.right<<"]"<<std::endl;
						}
						std::cerr<<"--"<<std::endl;
						vv = v;
						while(ww!=vv){
							vv = cst.parent(vv);
							std::cerr<<vv.l<<"-["<<vv.left<<","<<vv.right<<"]"<<std::endl;
						}
						std::cerr<<"lca = "<<lca.l<<"-["<<lca.left<<","<<lca.right<<"]"<<std::endl;
						if(lca.l and lca.left and lca.right<cst.csa.size()-1){
							std::cerr<<cst.lcp[lca.left]<<","<<cst.lcp[lca.right+1]<<std::endl;
						}
						std::cerr<<"vv = "<<vv.l<<"-["<<vv.left<<","<<vv.right<<"]"<<std::endl;
					}
					BOOST_REQUIRE(lca==vv);
				}
*/				
				BOOST_MESSAGE("Test ith_child(v,i).");
				size_type edges = 0;
				std::vector<size_type> child_number(nodesvec.size());
				for(size_type i=0; i<nodesvec.size();++i){
					node_type v = nodesvec[i];
					size_type j=1;
					while(cst.ith_child(v,j)!=cst.root())
						++j;	
					edges += j-1;
					child_number[i] = j-1;	
				}
				BOOST_MESSAGE("Cst consists of "<<edges<<" edges.");
				BOOST_REQUIRE(edges+1 == nodes.size());
				size_type dfsnodecnt = dfs(cst, cst.root());
				BOOST_MESSAGE("Cst consists of "<<dfsnodecnt<<" nodes.");
				BOOST_REQUIRE(dfsnodecnt==nodes.size());



/*
   				size_type char_pos=0;
				for(size_type i=1; i<=cst.csa.sigma; ++i){
					node_type child = cst.child(cst.root(), cst.csa.comp2char[(unsigned char)i], char_pos);
					BOOST_MESSAGE("char = "<< (char)cst.csa.comp2char[(unsigned char)i]);
					BOOST_MESSAGE(child.l<<"-["<<child.left<<","<<child.right<<"]");
				}
				size_type first_suff = cst.csa(0);
				node_type longest_suffix(cst.csa.size(), first_suff, first_suff);
				BOOST_REQUIRE( nodes.find(longest_suffix) != nodes.end() );
				for(size_type i=1; i<= longest_suffix.l; ++i){
					std::cerr<<(char)cst.edge(longest_suffix, i);
				}
				std::cerr<<std::endl;
				
				BOOST_MESSAGE("Test edge(v,d).");
				for(size_type i=0; i<cst.csa.size(); ++i){
					node_type node = cst.ith_leaf(i+1);	
					while( nodes.find(node) == nodes.end()  ){
						nodes.insert(node);
						BOOST_REQUIRE( nodes.size() < 2*cst.csa.size() );
						node_type newnode = cst.parent(node);
						BOOST_REQUIRE(newnode.l <= node.l);
						for(size_type j=1;j <= node.l-newnode.l; ++j){
							size_type d = newnode.l+j;
							unsigned char c = cst.edge(node, d);
							BOOST_REQUIRE( c == text[ cst.csa[node.left]+d-1 ] );
						}
						node = newnode;
					}
				}
*/
				BOOST_MESSAGE("Test child(v,c)");
				for(size_type i=0; i<nodesvec.size();++i){
					node_type v = nodesvec[i], child;
					size_type j=1;
					while( (child = cst.ith_child(v,j) ) !=cst.root()){
						unsigned char c = cst.edge(child, v.l+1);
						size_type char_pos;
						node_type child1 = cst.child(v, c, char_pos);
						node_type child2 = cst.child_linear(v, c, char_pos);
						if(child1 != child2){
							BOOST_MESSAGE("parent = "<<v);
							BOOST_MESSAGE("char c = "<<c);
							BOOST_MESSAGE("child 1 = "<<child1);
							BOOST_MESSAGE("child 2 = "<<child2);
						}
						BOOST_REQUIRE( child1 == child2 );
						++j;
					}
				}
/*				BOOST_MESSAGE("Test sl(v).");
				for(size_type i=0; i < 10*nodes.size(); ++i){
					node_type node = nodesvec[rand()%nodesvec.size()];
					node_type sl = cst.sl(node);
					for(size_type d=1; d < node.l; ++d){
						BOOST_REQUIRE( cst.edge(node, d+1) == cst.edge(sl, d) );
					}
				}
*/
				BOOST_MESSAGE("Test algorithm::count(cst, pattern, pattern_len)");
				size_type pattern_len = 10;
				for(size_t i=0; i + pattern_len - 1 <cst.csa.size(); ++i){
					BOOST_REQUIRE( algorithm::count(cst.csa, (const unsigned char*)text+i, pattern_len) > 0 );
				}

				BOOST_MESSAGE("Test children(v).");
				for(size_type i=0; i < nodesvec.size(); ++i){
					node_type node = nodesvec[i];
					if( cst.children(node) != child_number[i] ){
						BOOST_MESSAGE("cst.children = "<<cst.children(node)<<" child_number[i]="<<child_number[i]);
					}
					BOOST_REQUIRE( cst.children(node) == child_number[i] );
				}

				if( !tested_serialize_and_load ){
					BOOST_MESSAGE("Check serialize");
					std::string file_name = "/tmp/test_cst";
					util::store_to_file(cst, file_name.c_str() );

					BOOST_MESSAGE("Test load");
					std::ifstream in;
					util::load_from_file(cst, file_name.c_str() );

					tested_serialize_and_load = true;
					goto test_methods;
				}

				delete [] text;
			}else{
				BOOST_MESSAGE("could not read test case");
			}
		}	
	}
}

BOOST_AUTO_TEST_SUITE_END()
